using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductCategory;
namespace CMSMicroservice.Protobuf.Validator.ProductCategory;

public class UpdateProductCategoryRequestValidator : AbstractValidator<UpdateProductCategoryRequest>
{
    public UpdateProductCategoryRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.ProductId)
            .NotNull();
        RuleFor(model => model.CategoryId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateProductCategoryRequest>.CreateWithOptions((UpdateProductCategoryRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
